/**
 *  A class to test use of our generic Stack class.
 *
 *  @author Nicholas R. Howe, modified by Sara Sheehan
 *  @version February 23, 2016
 */
public class StackTester {
	
    /** Runs the tests */
    public static void main(String[] args) {
    	
    		// integer stack
    		Stack<Integer> intStack = new Stack<Integer>();
    		intStack.push(3);
    		intStack.push(2);
    		intStack.push(1);
    		
    		while (!intStack.empty()) {
    			System.out.println("Popping: " + intStack.pop());
    		}
    		System.out.println("Empty!");

        // popping an empty stack to see what will happen
        try {
            intStack.pop();
        } catch (Exception e) {
            System.out.println("Exception caught: " + e.getClass() + "\n");
        }

        // String stack
        Stack<String> stringStack = new Stack<String>();
        stringStack.push("bold");
        stringStack.push("the");
        stringStack.push("favors");
        // peek at the stack but don't pop
        String peeking = stringStack.peek();
        System.out.println("Peeking: " + peeking + "\n");
        stringStack.push("fortune");
        
        // TODO, uncomment below and deep copy the stack (optional)
        //Stack<String> stringStack2 = new Stack<String>(stringStack);
        
        while (!stringStack.empty()) {
        		System.out.println("Popping: " + stringStack.pop());
        }
        System.out.println("Empty!");
    }
}
